<?
require_once ("RdfDocument.php");

class AddressbookDocument extends RdfDocument {
	public function getStructure() {
		return array (
			'name' => new RdfInputText(array (
				'label' => PROFILE_NAME,
				'fields' => array (
					'http://xmlns.com/foaf/0.1/name' => 'N.N.'
				),

				
			), new RdfVisibilityWorld()),

			'phone' => new RdfInputText(array (
				'label' => PROFILE_PHONE,
				'fields' => array (
					'http://xmlns.com/foaf/0.1/phone' => '1234567890'
				),

				
			), new RdfVisibilityAllContacts($this->getSubject())),

			'pos' => new RdfInputPos(array (
				'label' => PROFILE_POS,
				'fields' => array (
					'lng' => '90',
					'lat' => '0'
				),

				
			), new RdfVisibilityHidden($this->getSubject())),

			
		);
	}
}

class RdfInputPos extends RdfInput {

	public function subRender($eleKey) {
		return "<input size='5' type='text' name='" . $eleKey . "[lat]' value='" . $this->data['fields']['lat'] . "'  /> ".FIELD_POS_LAT." / <input size='5' type='text' name='" . $eleKey . "[lng]' value='" . $this->data['fields']['lng'] . "'  /> " . FIELD_POS_LNG;
	}

	public function validate() {
		
		
		/*if (!empty($this->data['fields']['lat']) && !is_numeric($this->data['fields']['lat']) || !is_numeric($this->data['fields']['lng'])) {
			$this->errors[] = "Länge und Breite müssen Zahlen sein.";
			return false;
		}*/

		return true;
	}

	public function saveData($store, $graph, $subject) {

		$store->query("DELETE FROM <$graph> { <$subject> <http://xmlns.com/foaf/0.1/based_near> ?pos . }" . "\n" .
		"WHERE { GRAPH <$graph> { <$subject> <http://xmlns.com/foaf/0.1/based_near> ?pos . } }");

		$store->query("DELETE FROM <$graph> {?node ?prop ?val . }" . "\n" .
		"WHERE { GRAPH <$graph> { ?node a <http://www.w3.org/2003/01/geo/wgs84_pos#Point> . } }");

		if (empty ($this->data['fields']['lat']) || empty($this->data['fields']['lng']))
			return;
		$store->query("INSERT INTO <$graph> { <$subject> <http://xmlns.com/foaf/0.1/based_near> _:pos . _:pos a <http://www.w3.org/2003/01/geo/wgs84_pos#Point> . _:pos  <http://www.w3.org/2003/01/geo/wgs84_pos#lat> '" . $this->data['fields']['lat'] . "' . _:pos <http://www.w3.org/2003/01/geo/wgs84_pos#long> '" . $this->data['fields']['lng'] . "' .}");

	}
	public function getRuleConsequence($subject) {
		return "permit_triple($subject,http://xmlns.com/foaf/0.1/based_near,*) && permit_instance(http://www.w3.org/2003/01/geo/wgs84_pos#Point)";
	}

	public function loadData($store, $graph, $subject) {
		$res = $store->query("SELECT ?lat ?lng" . "\n" .
		"FROM <$graph>" . "\n" .
		"WHERE  {?pos a <http://www.w3.org/2003/01/geo/wgs84_pos#Point>. ?pos <http://www.w3.org/2003/01/geo/wgs84_pos#lat> ?lat . ?pos <http://www.w3.org/2003/01/geo/wgs84_pos#long> ?lng . }" . "\n" .
		"LIMIT 1" . "\n", "row");
		$this->data['fields']['lat'] = @ $res['lat'];
		$this->data['fields']['lng'] = @ $res['lng'];

		return @ $res['val'];
	}
}

class RdfInputText extends RdfInput {

	public function subRender($eleKey) {
		return "<input type='text' name='" . $eleKey . "[" . $this->getPropertyUri() . "]' value='" . $this->getValue() . "'  />";
	}

	public function validate() {
		// nothing to do, fine
		return true;
	}

	public function saveData($store, $graph, $subject) {
		$prop = $this->getPropertyUri();
		$val = $this->getValue();
		$store->query("DELETE FROM <$graph> { <$subject> <$prop> ?val . }" . "\n" .
		"WHERE { GRAPH <$graph> { <$subject> <$prop> ?val . } }");

		if (empty ($val))
			return;
		$store->query("INSERT INTO <$graph> { <$subject> <$prop> '$val' . }");
	}
	public function getRuleConsequence($subject) {
		return "permit_triple(" . $subject . "," . $this->getPropertyUri() . ",*)";
	}

	private function getPropertyUri() {
		return key($this->data['fields']);
	}

	private function getValue() {
		return $this->data['fields'][$this->getPropertyUri()];
	}

	public function loadData($store, $graph, $subject) {
		$prop = $this->getPropertyUri();
		$res = $store->query("SELECT ?val" . "\n" .
		"FROM <$graph>" . "\n" .
		"WHERE  { <$subject> <$prop> ?val . }" . "\n" .
		"LIMIT 1" . "\n", "row");
		$this->data['fields'][$prop] = @ $res['val'];
		return @ $res['val'];
	}
}