<?
require_once("RdfVisibility.php");

abstract class RdfInput {

	protected $data = array();
	protected $visibility;
	
	protected $errors = array();
	
	public function __construct($data,$visibility) {
		$this->data = $data;
		$this->visibility = $visibility;
	}

	public final function render($eleKey) {
		$key = key($this->data['fields']);
	    $ret = "<tr><th>".$this->data['label']."</th><td>".$this->subRender($eleKey)."</td> ".$this->renderVisibilityOptions($eleKey). "</tr>";	
	    if (count($this->errors) > 0) {
	    	$ret .= "<tr><td></td><td colspan='2'><ul class='error'><li>" . implode("</li><li>",$this->errors) . "</li></ul></td></tr>";
	    }
	    return $ret;
	}
    
    abstract public function subRender($eleKey);
    abstract public function validate();
	abstract public function getRuleConsequence($subject);
	
	abstract public function loadData($store, $graph, $subject);
	abstract public function saveData($store, $graph, $subject);
	
	public function saveVisibility($store, $graph, $ele) {
		$this->visibility->save($store,$graph, $ele);
	}
	
	
	
	public function update($data, $subject) {
		// update data
		foreach ($data as $key => $value) {
			if (isset($this->data['fields'][$key])) $this->data['fields'][$key] = $value;
		}
		// update visibility
		$type = $data['_visibility']['_type'];
		if (trim($type) == "" || !class_exists($type)) return;
		$newVis = new $type($subject);
		$newVis->setOptions($data['_visibility']);		
		$this->visibility = $newVis;
	}
	
	public function renderVisibilityOptions($eleKey) {
		$ret = "<td><select onchange='reloadVisOptions(this,\"".$eleKey."\")' name='".$eleKey."[_visibility][_type]' size='0'>";
		foreach (RdfVisibility::$typesAndLabels as $t => $l) {
			$ret .= "<option value='".$t."' ";
			if ($t == get_class($this->visibility)) $ret .= " selected='selected' ";
			$ret .= ">".$l."</option>\n";
		}
		$ret .= "</select></td><td id='vis_options_".$eleKey."'>" . $this->visibility->render($eleKey) ."</td>";
		return $ret;
	}

	
	public function getVisibility() {
		return $this->visibility;
	}
	
	public function setVisibility($aVis) {
		$this->visibility = $aVis;
	}
}
