// if the firebug console is missing, ignore calls to it
if (! ("console" in window) || !("firebug" in console)) {
    var names = ["log", "debug", "info", "warn", "error", "assert", "dir", "dirxml", "group"
                 , "groupEnd", "time", "timeEnd", "count", "trace", "profile", "profileEnd"];
    window.console = {};
    for (var i = 0; i <names.length; ++i) window.console[names[i]] = function() {};
}
// end firebug fix

var contactDetailsCache = {};
var curContactUri = "";
function showContactDetails(ele) {
	if (ele == undefined) return;
	console.log("showContactDetails(%o)",ele);
	
	if (ele.name == curContactUri) return showContactDetailsComplete(ele);
	
	if (contactDetailsCache[ele.name] != undefined) {
		$('details').innerHTML = contactDetailsCache[ele.name];
		showContactDetailsComplete(ele);
	} 
	else {
		$('details').innerHTML = '<p>'+CONTACTS_LOADING+'</p>';
		new Ajax.Updater($('details'), 'callback/details.php', {
			  parameters: { webId: ele.name },
			  onComplete: function(transport) {
				  contactDetailsCache[ele.name] = transport.responseText;
				  showContactDetailsComplete(ele);
			  }
			});
	}
	return false;
}

function showContactDetailsComplete(ele) {
	console.log("showContactDetailsComplete(%o)",ele);
	
	$$('#contacts a').each(function(link) {link.removeClassName('active')});
	$$('#groups a.active').each(function(link) {link.removeClassName('active').addClassName('clicked')});
	ele.addClassName('active');

	$('details-button').show().name = ele.name;
	$('details-button').title = ele.title;
	curContactUri = ele.name;
}

var contactListCache = {};
var curGroup = "";
function showContactList(ele) {
	console.log("showContactList(%o)",ele);
	
	if (contactListCache[ele.name] != undefined) {
		$('contacts-list').innerHTML = contactListCache[ele.name];
			showContactListComplete(ele);
	} 
	else {
		$('contacts-list').innerHTML = '<li>'+CONTACTS_LOADING+'</li>';
		new Ajax.Request('callback/lists.php', {
			  parameters: { group: ele.name }, 
			  onComplete: function(transport) {
				  var htmlStr = "";
					transport.responseText.evalJSON().each(function(contact) {
						htmlStr += "<li><a href='#' name='"  + contact.uri + "' onclick=\"return showContactDetails(this);\" title='"+ contact.name +"'>"+ contact.name +"</a></li>";
					});
				  $('contacts-list').innerHTML = htmlStr;
				  contactListCache[ele.name] = htmlStr;
				  showContactListComplete(ele);
			  }
			});
	}
	return false;
}

function showContactListComplete(ele) {
	console.log("showContactListComplete(%o)",ele);
	
	$$('#groups a').each(function(link) {link.removeClassName('active').removeClassName('clicked')});
	ele.addClassName('active');

	$('contact-button').title = ele.title;
	curGroup = ele.name;
	
	new Proto.Menu({
		  selector: '#contacts-list a',
		  className: 'menu osx',
		  menuItems: contactContextMenuItems // array of menu items
		});
	
	showContactDetails($$('#contacts a').toArray()[0]);
}

var groupListCache = {};

function showGroupList(ele) {
	console.log("showGroupList(%o)",ele);

	$('groups-list').innerHTML = '<li>'+CONTACTS_LOADING+'</li>';
	new Ajax.Request('callback/groups.php', {
		  onComplete: function(transport) {
		  	var htmlStr = "<li><a href='#' name='_' onclick=\"return showContactList(this);\" title='"+CONTACTS_GROUP_ALL+"'>"+CONTACTS_GROUP_ALL+"</a></li>";
		  	groupListCache = transport.responseText.evalJSON();
			groupListCache.each(function(group) {
				htmlStr += "<li><a href='#' name='" + group.uri + "' onclick=\"return showContactList(this);\" title='" + group.name + "'>" + group.name + "</a></li>";
			});
			
			$('groups-list').innerHTML = htmlStr;
			showGroupListComplete($$('#groups a').toArray()[0]);
		  }
	});
	return false;
}

function showGroupListComplete(ele) {
	console.log("showGroupListComplete(%o)",ele);

	ele.addClassName('active');
	showContactList(ele);

	new Proto.Menu({
		  selector: '#groups-list a',
		  className: 'menu osx',
		  menuItems: groupContextMenuItems // array of menu items
		});
}


function addContact() {
	console.log("addContact()");

	var newContact = prompt(CONTACTS_CONTACT_ADD_WEBID,"http://www.w3.org/People/Berners-Lee/card#i");
	if (newContact == null || newContact == "") {
		return;
	}
	
	new Ajax.Request('callback/contactadd.php', {
	  parameters: { contact: newContact },
	  onComplete: function(transport) {
		  var resp = transport.responseText;
		  if (resp == "SUCCESS") {
			  // refresh group list
			  curGroup = null;
			  contactListCache = {};
			  showContactList($$('#groups a').toArray()[0]);
			  return;
		  }
		  alert(CONTACTS_ERROR + " " + resp);
	  }
	});
	
	return;
}

function removeContact(ele) {
	console.log("removeContact(%o)",ele);
	
	var c = confirm(CONTACTS_CONTACT_DELETE_CONFIRM.replace('%0',ele.title));
	if (!c) return;
	
	new Ajax.Request('callback/contactdelete.php', {
	  parameters: { contact: ele.name },
	  onComplete: function(transport) {
		  var resp = transport.responseText;
		  if (resp == "SUCCESS") {
			  // refresh group list
			  curGroup = null;
			  curContactUri = null;
			  contactListCache = {};
			  $('details').innerHTML = '';
			  showContactList($$('#groups a').toArray()[0]);
			  return;
		  }
		  alert(CONTACTS_ERROR + " " + resp);
	  }
	});
	
	return;
}

function removeGroup(ele) {
	console.log("removeGroup(%o)",ele);
	
	if (ele.name == "_") {
		alert(CONTACTS_GROUP_ALL_DELETE);
		return;
	}
	
	var c = confirm(CONTACTS_GROUP_DELETE_CONFIRM.replace('%0',ele.title));
	if (!c) return;
	
	new Ajax.Request('callback/groupdelete.php', {
	  parameters: { group: ele.name },
	  onComplete: function(transport) {
		  var resp = transport.responseText;
		  if (resp == "SUCCESS") {
			  // refresh group list
			  showGroupList(new Element("a"));
			  return;
		  }
		  alert(CONTACTS_ERROR + " " + resp);
	  }
	});
	
	return;
}

function addGroup() {
	console.log("addGroup()");

	var newName = prompt(CONTACTS_GROUP_ADD_NAME,"");
	if (newName == null || newName == "") {
		return;
	}
	
	new Ajax.Request('callback/groupadd.php', {
	  parameters: { name: newName },
	  onComplete: function(transport) {
		  var resp = transport.responseText;
		  if (resp == "GROUP_EXISTS") {
			  alert(CONTACTS_GROUP_ADD_EXISTS);
			  return;
		  }
		  if (resp == "SUCCESS") {
			  // refresh group list
			  showGroupList(new Element("a"));
			  return;
		  }
		  alert(CONTACTS_ERROR + " " + resp);
	  }
	});
	
	return;
}

var onTheMove = false;
function moveCursor(dir) {
	console.log("moveCursor(%o)",dir);

	if (onTheMove) return;
	onTheMove = true;
	$$('#contacts a').each(function(link, index) {
		if (link.classNames().member('active')) {
			var newEle = $$('#contacts a').toArray()[index+dir];
			if (newEle != undefined) {
				showContactDetails(newEle);
			    throw $break;
			}
		}
	});
	onTheMove = false;
	return;
}

function cursorUp() {moveCursor(-1);}

function cursorDown() {moveCursor(1);}

var reqUpdater = null;
function initAddressBook() {
	console.log("initAddressBook()");
	
	new Proto.Menu({
		  selector: '#contacts',
		  className: 'menu osx',
		  menuItems: contactListContextMenuItems // array of menu items
		});

		new Proto.Menu({
		  selector: '#groups',
		  className: 'menu osx',
		  menuItems: groupListContextMenuItems // array of menu items
		});

		document.onkeyup = function keyPress(e) {
			wkey = e.which?e.which:window.event.keyCode;
			switch(wkey) {
			case 38:
			  cursorUp();
		      break;
		    case 40:
			  cursorDown();
		      break;
		   }
		} 
		
	// invoke with dummy element, will be overwritten soon
	showGroupList(new Element("a"));
	
	reqUpdater = new Ajax.PeriodicalUpdater('requests', 'callback/requests.php',{frequency: 15})
}

function toggleCheckbox(ele) {
	// get sibling element of type checkbox and flip its value
	ele.previousSiblings().each(function(ele) {
		if (ele.tagName == "INPUT") {
			ele.checked = !ele.checked;
		}
	})
}

var curContactEle = null;
function groupEditShow(ele) {
	console.log("groupEditShow(%o)",ele);

	curContactEle = ele;
	
	new Ajax.Request('callback/groupmember.php', {
		  parameters: {contact: ele.name},
		  onComplete: function(transport) {
			  var data = transport.responseText.evalJSON();
  			  var content = "<form onsubmit='return groupEditSave()' id='group-edit'><h3>"+ CONTACTS_GROUPEDIT_TITLE.replace('%0',curContactEle.title) + "</h3><ul>";
				
				data.each(function(group) {
					content += "<li><input type='checkbox' name='group[]' value='" + group.uri + "' ";
					if (group.contact != null) content += " checked='checked' ";
					content += " > <span onclick='toggleCheckbox(this)'>" + group.name + "</span></li>";
				}); 
				
				content += "</ul></form><button onclick='return groupEditSave()'>"+CONTACTS_GROUPEDIT_SAVE+"</button>" +
					"<button onclick='return groupEditCancel()'>"+CONTACTS_GROUPEDIT_CANCEL+"</button>";
				$('shadow').show();
				$('popup').update(content).show(); 
				
		  }
		});
	
	return false;
}

function groupEditSave() {
	console.log("groupEditSave()");

	if (curContactUri == null) return groupEditCancel();
	
	var data = $('group-edit').serialize(true);
	data['contactUri'] = curContactEle.name;
	
	new Ajax.Request('callback/groupedit.php', {
		  parameters: data,
		  onComplete: function(transport) {
			  var resp = transport.responseText;
			  if (resp == "SUCCESS") {
				  contactListCache = {};
				  groupEditCancel();
				  return;
			  }
			  alert(CONTACTS_ERROR + " " + resp);
		  }
		});
	
	return false;
}

function groupEditCancel() {
	$('popup').hide().update(""); 
	$('shadow').hide();
	curContactEle = null;
	return false;
}
	

function reloadVisOptions(selectEle,eleKey) {
	console.log("reloadVisOptions(%o,%s)",selectEle, eleKey);

	new Ajax.Request('callback/visoptions.php', {
		  parameters: {type: selectEle.value, key: eleKey},
		  onComplete: function(transport) {
			  $('vis_options_' + eleKey).update(transport.responseText);
		  }
		});
}

var contactContextMenuItems = [
   {
     name: CONTACTS_CONTACT_CONTEXT_DETAILS,
 className: 'show', 
 callback: function(e) {
  showContactDetails(e.target);
     }
   },{
     name: CONTACTS_CONTACT_CONTEXT_GROUPS,
 className: 'addgroup', 
 callback: function(e) {
  groupEditShow(e.target);
     }
   },{
     name: CONTACTS_CONTACT_CONTEXT_DELETE,
 className: 'delete', 
 callback: function(e) {
	   removeContact(e.target);
     }
   },{
     separator: true
   },{
     name: CONTACTS_CONTACT_CONTEXT_NEW,
 className: 'add',
     callback: function(e) {
	   addContact();
	   
   }
   }
 ]
 
 var contactListContextMenuItems = [
  {
      name: CONTACTS_CONTACT_CONTEXT_NEW,
  className: 'add',
      callback: function(e) {
 	   addContact();
 	   
    }
    }
  ]

 var groupContextMenuItems = [
  {
    name: CONTACTS_GROUP_CONTEXT_SHOW, //'Mitglieder anzeigen',
className: 'show', 
callback: function(e) {
	  showContactList(e.target);
    }
  },{
    name: CONTACTS_GROUP_CONTEXT_ADD,//'Kontakt hinzufügen',
className: 'addcontact', 
callback: function() {
	   addContact();
    }
  },{
    name: CONTACTS_GROUP_CONTEXT_DELETE,//'Gruppe löschen',
className: 'delete', 
callback: function(e) {
	  removeGroup(e.target);
    }
  },{
    separator: true
  },{
    name: CONTACTS_GROUP_CONTEXT_NEW,//'Neue Gruppe',
className: 'add',
    callback: function() {
     addGroup();
    }
  }
]

var groupListContextMenuItems = [
{
   name: CONTACTS_GROUP_CONTEXT_NEW,
   className: 'add',
       callback: function(e) {
    addGroup();
       }
     }
   ]
   
   
   
function update_vis_group(selectNode,selectedGroup) {
	alert(selectedGroup);
	
}

function approveRequest(uri) {
	console.log("approveRequest(%s)",uri);
	
	new Ajax.Request('callback/contactadd.php', {
		  parameters: { contact: uri },
		  onComplete: function(transport) {
			  var resp = transport.responseText;
			  if (resp == "SUCCESS") {
				  // refresh group list
				  curGroup = null;
				  contactListCache = {};
				  showContactList($$('#groups a').toArray()[0]);
				  $('requests').update('');
				  reqUpdater.start();
				  return;
			  }
			  alert(CONTACTS_ERROR + " " + resp);
		  }
		});
}
 

function ignoreRequest(uri) {
	console.log("ignoreRequest(%s)",uri);
	
	new Ajax.Request('callback/requestignore.php', {
		  parameters: { contact: uri },
		  onComplete: function(transport) {
				$('requests').update('');
				reqUpdater.start();
		  }
		});
}
