<?php

function createKeyCert($webId, $cert_key_file = "") {
	// create a fitting file name for the given url
	$uri_info = parse_url($webId) or die("no URI given");
	$key_name = $uri_info['host']."_".str_replace("/","_",$uri_info['path']);
	
	if (!is_dir(KEY_DIR)) @mkdir(KEYDIR) or die("Unable to write to " . KEYDIR);
	if (!is_writable(KEY_DIR)) die("Unable to write to " . KEYDIR);
	
	// kill output for system() commands
	ob_start();
	// create RSA key
	$key_file = escapeshellarg(KEY_DIR . "/" . $key_name . ".key.pem");
	$genkey_cmd = OPENSSL_BIN . " genrsa -out " . $key_file . " 1024";
	putenv("RANDFILE=/tmp/ssl.rand");
	@system($genkey_cmd);
	// create SPKAC
	$spkac_cmd = OPENSSL_BIN . " spkac -key " . $key_file;
	$spkac = @system($spkac_cmd);
	
	if (strlen($spkac) != SPKAC_LEN) die("Failed to create Key / SPKAC");
	
	// dispatch SPKAC
	$cert_req = PELDS_CERT . 
		"?url=" . urlencode($webId) . 
		"&lifetime=" . CERT_LIFETIME .
		"&spkac=" . urlencode(str_replace("SPKAC=","",$spkac));
	
	$cert = file_get_contents($cert_req);
	if (!$cert) die("Failed to retrieve Cert from " . PELDS_CERT);
	
	$cert_file_der = KEY_DIR . "/" . $key_name . ".crt.der";
	file_put_contents($cert_file_der,$cert);
	
	// convert cert to PEM format
	$cert_file_pem = KEY_DIR . "/" . $key_name . ".crt.pem";
	@system(OPENSSL_BIN . " x509 -inform DER -in " . $cert_file_der . " -out ".$cert_file_pem);
	
	// combine private key and certificate (finally...)
	if (empty($cert_key_file)) $cert_key_file = KEY_DIR . "/" . $key_name . ".keycrt.pem";
	
	@system("cat " . $key_file . " " . $cert_file_pem . " > " . $cert_key_file);
	
	// remove all previous files
	@system("rm ".implode(" ",array($key_file,$cert_file_der,$cert_file_pem)));
	
	// end output suppression
	ob_end_clean();
	
	return $key_name . ".keycrt.pem";
}

function getModExp($x509file) {
	$command = "openssl asn1parse -i -in " .$x509file;
	$rsa_cert_struct = `$command`;	
	$rsa_key = explode("\n", $rsa_cert_struct);
	
	$modulus = explode(":", $rsa_key[2]);
	$exponent = explode(":", $rsa_key[3]);
	
	return(array( 'modulus'=>trim($modulus[3]), 'exponent'=>hexdec($exponent[3]) ) );
}


function exportCert($pemFile) {
	//openssl pkcs12 -export  -in .pem -inkey .pem  -out horst.p12 
	
	
}
?>
