<?php
require_once("arc/ARC2.php");
// TODO: move db access to config
function getTempStore() {
	$config = array(
		/* db */
		'db_host' => TEMP_STORE_HOST, /* default: localhost */
		'db_name' => TEMP_STORE_NAME,
		'db_user' => TEMP_STORE_USER,
		'db_pwd'  => TEMP_STORE_PASS,
		/* store */
		'store_name' => 'addressbook_rdf_tmp', // TODO: unique?
		'arc_reader_ssl_local_cert' => KEY_DIR . "/" . @$_SESSION['clientCert'],
	);
	
	$store = ARC2::getStore($config);
	if (!$store->isSetUp()) {
		$store->setUp();
	}
	return $store;
}

function getSystemStore() {
	return getStore(STORE_ENDPOINT,APP_CERT);
}

function getSystemUpdateStore() {
	return getStore(STORE_UPDATE_ENDPOINT,APP_CERT);
}

function getStore($endpoint,$userCrt) {
	if (empty($endpoint) || empty($userCrt)) die ("Failed to create store");
	$config = array(
		'remote_store_endpoint' => $endpoint,
		'arc_reader_ssl_local_cert' => $userCrt,		
	);
	return ARC2::getRemoteStore($config);
}

function getUserCert() {
	@session_start();
	return KEY_DIR . "/" . $_SESSION['clientCert'];
}

function getUserUpdateStore() {
	return getStore(STORE_UPDATE_ENDPOINT,getUserCert());
}

function getUserStore() {
	return getStore(STORE_ENDPOINT,getUserCert());
}

class RuleUpdater {
	private $a = array();
	private $errors = array();
	
	public function updateRules($cert, $store, $ruleStr) {
		ARC2::inc('Reader');
		$this->a = array( 'arc_reader_ssl_local_cert' => $cert);
		$reader = new ARC2_Reader($this->a, $this);
		
		$reader->setHTTPMethod("POST");
		$reader->setCustomHeaders("Content-Type: application/x-www-form-urlencoded");
		$suffix = '&dataset=' . rawurlencode($store);
		$reader->setMessageBody('rules=' . rawurlencode($ruleStr) . $suffix);
		
		$reader->activate(STORE_RULE_ENDPOINT, '', 0, 100);
	
		$resp = '';
		while ($d = $reader->readStream()) {
			$resp .= $d;
		}
	
		$reader->closeStream();
		$this->errors = $reader->getErrors();
		unset($this->reader);
	}
	
	public function updateUserRules($store,$ruleStr) {
		$cert = KEY_DIR . "/" . $_SESSION['clientCert'];
		return $this->updateRules($cert,$store,$ruleStr);
	}
	
	public function getErrors() {
		return $this->errors;
	}
}

function parseAccept() {
	$accepts_raw = explode(",",$_SERVER['HTTP_ACCEPT']);
	$accepts = array();
	foreach ($accepts_raw as $accept_raw) {
		$sub = explode(";",$accept_raw);	
		$accept = array('contentType' => trim($sub[0]), 
			'priority' => isset($sub[1]) ? trim(str_replace("q=","",strtolower($sub[1]))) : 1 );
		$accepts[] = $accept;
	}
	return $accepts;
}

function getAcceptTopPrio() {
	$largest_prio = 0;
	$ct = "";
	$accepts = parseAccept();
	foreach ($accepts as $accept) {
		if ($accept['priority'] > $largest_prio) {
			$largest_prio = $accept['priority'];
			$ct = $accept['contentType'];
		}
	}
	return $ct;
}